# Repository path:    $HeadURL: https://90.145.156.222/DMS-Houtribdijk/code/nc-to-thredds/source/calcmoments.py $
# Last committed:     $Revision: 380303 $; $Author: vvuik $; $Date: 2019-10-21 11:46:46 +0200 (ma, 21 okt 2019) $
#
# -*- coding: utf-8 -*-
"""
Created on Tue Mar 26 13:13:17 2019

@author: vuik
"""

import pandas as pd
import numpy as np
from bisect import bisect

def calcmoments(fx,vy,fmin=-9999,fmax=9999):
    
    if np.min(np.diff(fx))<=0:
        raise ValueError('fx should be increasing')
    
    imin = bisect(fx,fmin)
    imax = bisect(fx,fmax)
    
    #    df = F(1);                                                      % bandwidth (Hz)
    #    for i=-2:4                                                      % calculation of moments of spectrum
    #    	moment(i+3)=sum(F(integmin:integmax).^i.*Snf(integmin:integmax))*df;
    #    %	fprintf('m%g  =  %g\n',i,moment(i+3));
    #    end
    
    fsel = fx[imin:imax]
    vsel = vy[imin:imax]
    
    m0  = np.trapz(vsel*(fsel**0),fsel)
    m1  = np.trapz(vsel*(fsel**1),fsel)
    m2  = np.trapz(vsel*(fsel**2),fsel)
    m3  = np.trapz(vsel*(fsel**3),fsel)
    m4  = np.trapz(vsel*(fsel**4),fsel)
    mm1 = np.trapz(vsel*(fsel**(-1)),fsel)
    mm2 = np.trapz(vsel*(fsel**(-2)),fsel)
    
    moments = pd.DataFrame({'mm2':mm2,'mm1':mm1,'m0':m0,'m1':m1,'m2':m2,'m3':m3,'m4':m4},index=[0])
    
    return moments